#include <algorithm>
#include <vector>

#include "caffe/layer.hpp"
#include "caffe/vision_layers.hpp"

namespace caffe {

template <typename Dtype>
void ReLULayer<Dtype>::Forward_cpu(const vector<Blob<Dtype>*>& bottom,
    vector<Blob<Dtype>*>* top) {
  const Dtype* bottom_data = bottom[0]->cpu_data();
  Dtype* top_data = (*top)[0]->mutable_cpu_data();
  const int count = bottom[0]->count();
  /*double bottommin=1.7e+308;
            	    	double bottommax=-1.7e+308;
            	    	for (int k=0;k<count;k++)
            	    	    	{
            	    	    		if (bottom_data[k]<bottommin)
            	    	    		{
            	    	    			bottommin=bottom_data[k];
            	    	    		}
            	    	    		if (bottom_data[k]>bottommax)
            	    	    		{
            	    	    			bottommax=bottom_data[k];
            	    	    		}
            	    	   }
            	    	LOG(INFO) << "ReLU-bottommin:" << bottommin << ", bottommax:" << bottommax;*/
  Dtype negative_slope = this->layer_param_.relu_param().negative_slope();
  for (int i = 0; i < count; ++i) {
    top_data[i] = std::max(bottom_data[i], Dtype(0))
        + negative_slope * std::min(bottom_data[i], Dtype(0));
  }

        	    	    	/*double topmin=1.7e+308;
        	    	    	double topmax=-1.7e+308;
        	    	    	for (int k=0;k<count;k++)
        	    	    	{
        	    	    		if (top_data[k]<topmin)
        	    	    		{
        	    	    			topmin=top_data[k];
        	    	    		}
        	    	    		if (top_data[k]>topmax)
        	    	    		{
        	    	    			topmax=top_data[k];
        	    	    		}
        	    	    	}
        	    	    	LOG(INFO) << "ReLU-topmin:" << topmin << ", topmax:" << topmax;*/
}

template <typename Dtype>
void ReLULayer<Dtype>::Backward_cpu(const vector<Blob<Dtype>*>& top,
    const vector<bool>& propagate_down,
    vector<Blob<Dtype>*>* bottom) {
  if (propagate_down[0]) {
    const Dtype* bottom_data = (*bottom)[0]->cpu_data();
    const Dtype* top_diff = top[0]->cpu_diff();
    Dtype* bottom_diff = (*bottom)[0]->mutable_cpu_diff();
    const int count = (*bottom)[0]->count();
    Dtype negative_slope = this->layer_param_.relu_param().negative_slope();
    for (int i = 0; i < count; ++i) {
      bottom_diff[i] = top_diff[i] * ((bottom_data[i] > 0)
          + negative_slope * (bottom_data[i] <= 0));
    }
  }
}


#ifdef CPU_ONLY
STUB_GPU(ReLULayer);
#endif

INSTANTIATE_CLASS(ReLULayer);


}  // namespace caffe
